<?php

namespace Pinpoint\Feefo\Block\Services;

use Magento\Framework\View\Element\Template;

/**
 * Class Reviews
 * @package Pinpoint\Feefo\Block\Services
 */
class Reviews extends Template
{
    /**
     * @var \Magento\Framework\Registry
     */
    protected $registry;

    /**
     * @var \Pinpoint\Feefo\Model\FeefoReview|\Pinpoint\Feefo\Model\FeefoServiceReview
     */
    protected $feefoReviews;

    /**
     * @var \Pinpoint\Feefo\Model\ResourceModel\FeefoServiceReview\Collection
     */
    protected $reviewCollection;

    /**
     * @var \Pinpoint\Feefo\Model\ResourceModel\FeefoServiceReview\Collection
     */
    protected $reviews;

    /**
     * @var \Pinpoint\Feefo\Helper\Data
     */
    protected $feefoHelper;

    /**
     * @var string
     */
    const SLIDER_ENABLED_CONFIG_PATH = 'pinpoint_feefo/service_widget/enabled';

    /**
     * Reviews constructor.
     * @param \Pinpoint\Feefo\Model\FeefoServiceReview $feefoReviews
     * @param \Magento\Framework\Registry $registry
     * @param Template\Context $context
     * @param array $data
     */
    public function __construct(
        \Pinpoint\Feefo\Model\FeefoServiceReview $feefoReviews,
        \Pinpoint\Feefo\Helper\Data $feefoHelper,
        \Magento\Framework\Registry $registry,
        Template\Context $context,
        array $data = []
    ) {
        $this->feefoReviews = $feefoReviews;
        $this->registry = $registry;
        $this->reviews = null;
        $this->reviewCollection = null;
        $this->feefoHelper = $feefoHelper;

        parent::__construct($context, $data);
    }

    /**
     * @param bool $forceUpdate
     * @return mixed|null|\Pinpoint\Feefo\Model\ResourceModel\FeefoServiceReview\Collection
     */
    public function getServiceReviews($forceUpdate = false)
    {
        return $this->feefoReviews->getServiceReviews($forceUpdate);
    }

    /**
     * @return mixed|null|\Pinpoint\Feefo\Model\ResourceModel\FeefoServiceReview\Collection
     */
    public function getSliderReviews()
    {
        return $this->feefoReviews->getSliderReviews();
    }

    /**
     * @return mixed
     */
    public function getAverageRating()
    {
        return $this->getAverageRating();
    }

    /**
     * @return bool
     */
    public function isEnabled()
    {
        return (bool)$this->feefoHelper->getConfig(self::SLIDER_ENABLED_CONFIG_PATH);
    }

}